
#include "qualified_dublincore.h"

const text_t qualified_dublin_core::formatName() {
  return "gsdl_qdc";
}

const text_t qualified_dublin_core::formatPrefix() {
  return "dc";
}

bool qualified_dublin_core::output_record(ostream &output, recptproto *protocol, const text_t &collection, 
				const text_t &record_OID) 
{
  return metaformat::output_record(output, protocol, collection, record_OID);
}

void qualified_dublin_core::output_metadata_header(ostream &output)
{ 
  output << "    <metadata>\n";
  
  if (this->oaiConfigure->getOAIVersion() <= 110){
    // output dublin core wrapper for OAI v1.1
    output << "      <gsdl_qdc xmlns=\"http://greenstone.org/namespace/gsdl_qdc/1.0\"\n"
	   << "          xmlns:xsi=\"http://www.w3c.org/2001/XMLSchema-instance\"\n"
	   << "          xsi:schemaLocation=\"http://greenstone.org/namespace/gsdl_qdc/1.0 \n"
	   << "                              http://greenstone.org/namespace/gsdl_qdc/1.0/gsdl_qdc.xsd\">\n";
  }
  else { 
    output << "      <gsdl_qdc:gsdl_qdc\n"
	   << "          xmlns:gsdl_qdc=\"http://greenstone.org/namespace/gsdl_qdc/1.0\"\n"
	   << "          xmlns:dc=\"http://purl.org/dc/terms/\"\n"
	   << "          xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
	   << "          xsi:schemaLocation=\"http://greenstone.org/namespace/gsdl_qdc/1.0 \n"
	   << "                              http://greenstone.org/namespace/gsdl_qdc/1.0/gsdl_qdc.xsd\">\n";
  }
}

void qualified_dublin_core::output_metadata_footer(ostream &output)
{
  if (this->oaiConfigure->getOAIVersion() <= 110) {
    output << "      </gsdl_qdc>" << endl;
  }
  else {
    output << "      </gsdl_qdc:gsdl_qdc>" << endl;
  }

  output << "    </metadata>" << endl; 
  output.flush();
}

bool qualified_dublin_core::output_formatdata(ostream &output)
{
  output << "    <metadataPrefix>gsdl_qdc</metadataPrefix>" << endl;
  output << "    <schema>http://greenstone.org/namespace/gsdl_qdc/1.0/gsdl_qdc.xsd</schema>" << endl;
  output << "    <metadataNamespace>http://greenstone.org/namespace/gsdl_qdc/1.0</metadataNamespace>"<<endl;
  return true;
}
